using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using WinICD.icdws;

namespace WinICD
{
	/// <summary>
	/// WinICD̃CtH[
	/// </summary>
	public class frmWinICD : System.Windows.Forms.Form
	{
		#region members

		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Button btQuery;
		private System.Windows.Forms.TextBox tbQuery;
		private System.Windows.Forms.ListBox lbResult;

		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox tbWord;
		private System.Windows.Forms.TextBox tbMeanig;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.ContextMenu cmnuItem;
		private System.Windows.Forms.MenuItem mnuFile;
		private System.Windows.Forms.MenuItem mnuExit;
		private System.Windows.Forms.MenuItem mnuSetting;
		private System.Windows.Forms.MenuItem mnuHelp;
		private System.Windows.Forms.MenuItem mnuVersion;
		private System.Windows.Forms.MenuItem mnuLink;
		private System.Windows.Forms.MenuItem mnuRef;
		private System.Windows.Forms.MenuItem mnuICD;
		private ICD icd = new ICD();
		private ITEM cur;
		#endregion

		public frmWinICD()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			resize();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.mnuVersion = new System.Windows.Forms.MenuItem();
			this.mnuSetting = new System.Windows.Forms.MenuItem();
			this.mnuLink = new System.Windows.Forms.MenuItem();
			this.cmnuItem = new System.Windows.Forms.ContextMenu();
			this.mnuRef = new System.Windows.Forms.MenuItem();
			this.mnuICD = new System.Windows.Forms.MenuItem();
			this.tbMeanig = new System.Windows.Forms.TextBox();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.mnuFile = new System.Windows.Forms.MenuItem();
			this.mnuExit = new System.Windows.Forms.MenuItem();
			this.mnuHelp = new System.Windows.Forms.MenuItem();
			this.panel2 = new System.Windows.Forms.Panel();
			this.lbResult = new System.Windows.Forms.ListBox();
			this.btQuery = new System.Windows.Forms.Button();
			this.tbQuery = new System.Windows.Forms.TextBox();
			this.tbWord = new System.Windows.Forms.TextBox();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// mnuVersion
			// 
			this.mnuVersion.Text = "o[W(&V)";
			this.mnuVersion.Click += new System.EventHandler(this.mnuVersion_Click);
			// 
			// mnuSetting
			// 
			this.mnuSetting.Index = 0;
			this.mnuSetting.Text = "ݒ(&S)";
			// 
			// mnuLink
			// 
			this.mnuLink.Enabled = false;
			this.mnuLink.Index = 0;
			this.mnuLink.Text = "֘ANi&L)";
			// 
			// cmnuItem
			// 
			this.cmnuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.mnuLink,
																					 this.mnuRef,
																					 this.mnuICD});
			// 
			// mnuRef
			// 
			this.mnuRef.Enabled = false;
			this.mnuRef.Index = 1;
			this.mnuRef.Text = "֘Ap(&R)";
			this.mnuRef.Click += new System.EventHandler(this.RefMenu_Click);
			// 
			// mnuICD
			// 
			this.mnuICD.Enabled = false;
			this.mnuICD.Index = 2;
			this.mnuICD.Text = "ICD(&I)";
			this.mnuICD.Click += new System.EventHandler(this.mnuICD_Click);
			// 
			// tbMeanig
			// 
			this.tbMeanig.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.tbMeanig.BackColor = System.Drawing.SystemColors.Window;
			this.tbMeanig.ContextMenu = this.cmnuItem;
			this.tbMeanig.Font = new System.Drawing.Font("lr SVbN", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.tbMeanig.Location = new System.Drawing.Point(248, 40);
			this.tbMeanig.Multiline = true;
			this.tbMeanig.Name = "tbMeanig";
			this.tbMeanig.ReadOnly = true;
			this.tbMeanig.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.tbMeanig.Size = new System.Drawing.Size(328, 368);
			this.tbMeanig.TabIndex = 2;
			this.tbMeanig.Text = "";
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(240, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 409);
			this.splitter1.TabIndex = 3;
			this.splitter1.TabStop = false;
			this.splitter1.SplitterMoved += new System.Windows.Forms.SplitterEventHandler(this.splitter1_SplitterMoved);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.mnuFile,
																					  this.mnuHelp});
			// 
			// mnuFile
			// 
			this.mnuFile.Index = 0;
			this.mnuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuSetting,
																					this.mnuExit});
			this.mnuFile.Text = "t@C(&F)";
			// 
			// mnuExit
			// 
			this.mnuExit.Index = 1;
			this.mnuExit.Text = "I(&X)";
			this.mnuExit.Click += new System.EventHandler(this.mnuExit_Click);
			// 
			// mnuHelp
			// 
			this.mnuHelp.Index = 1;
			this.mnuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					this.mnuVersion});
			this.mnuHelp.Text = "wv(&H)";
			// 
			// panel2
			// 
			this.panel2.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.lbResult,
																				 this.btQuery,
																				 this.tbQuery});
			this.panel2.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(240, 409);
			this.panel2.TabIndex = 0;
			// 
			// lbResult
			// 
			this.lbResult.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.lbResult.IntegralHeight = false;
			this.lbResult.ItemHeight = 12;
			this.lbResult.Location = new System.Drawing.Point(0, 64);
			this.lbResult.Name = "lbResult";
			this.lbResult.Size = new System.Drawing.Size(240, 344);
			this.lbResult.Sorted = true;
			this.lbResult.TabIndex = 2;
			this.lbResult.SelectedIndexChanged += new System.EventHandler(this.lbResult_SelectedIndexChanged);
			// 
			// btQuery
			// 
			this.btQuery.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.btQuery.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btQuery.Location = new System.Drawing.Point(192, 32);
			this.btQuery.Name = "btQuery";
			this.btQuery.Size = new System.Drawing.Size(48, 24);
			this.btQuery.TabIndex = 1;
			this.btQuery.Text = "";
			this.btQuery.Click += new System.EventHandler(this.btQuery_Click);
			// 
			// tbQuery
			// 
			this.tbQuery.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.tbQuery.Location = new System.Drawing.Point(8, 8);
			this.tbQuery.Name = "tbQuery";
			this.tbQuery.Size = new System.Drawing.Size(232, 19);
			this.tbQuery.TabIndex = 0;
			this.tbQuery.Text = "";
			// 
			// tbWord
			// 
			this.tbWord.Font = new System.Drawing.Font("MS UI Gothic", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.tbWord.Location = new System.Drawing.Point(248, 8);
			this.tbWord.Name = "tbWord";
			this.tbWord.Size = new System.Drawing.Size(328, 22);
			this.tbWord.TabIndex = 1;
			this.tbWord.Text = "";
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 409);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(576, 20);
			this.statusBar1.TabIndex = 4;
			// 
			// frmWinICD
			// 
			this.AcceptButton = this.btQuery;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(576, 429);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.splitter1,
																		  this.tbWord,
																		  this.panel2,
																		  this.statusBar1,
																		  this.tbMeanig});
			this.Menu = this.mainMenu1;
			this.Name = "frmWinICD";
			this.Text = "WinICD";
			this.SizeChanged += new System.EventHandler(this.frmWinICD_SizeChanged);
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmWinICD());
		}

		private void btQuery_Click(object sender, System.EventArgs e)
		{
			statusBar1.Text = "...";
			lbResult.Items.Clear();
			WORD[] words = icd.SearchWord(tbQuery.Text,true);
			if(words == null)
			{
				statusBar1.Text = "word not found.";
				return;
			}
			foreach(WORD word in words)
			{
				lbResult.Items.Add(new ListItem(word) );
			}
			if(words.Length == 1) 
			{
				ITEM item = icd.GetItemById(words[0].id);
				tbMeanig.Text = item.meaning;
				tbWord.Text = item.word.title;
				statusBar1.Text = "1 word.";
			} 
			else 
			{
				statusBar1.Text = "" + words.Length + " words.";
			}
		}

		private void splitter1_SplitterMoved(object sender, System.Windows.Forms.SplitterEventArgs e)
		{
			resize();
		}
		private void resize()
		{
			tbMeanig.Left = splitter1.Left + splitter1.Width;
			tbMeanig.Width = ClientRectangle.Width - splitter1.Left - splitter1.Width;
			tbWord.Left = splitter1.Left + splitter1.Width;
			tbWord.Width = ClientRectangle.Width - splitter1.Left - splitter1.Width;
		}

		private void frmWinICD_SizeChanged(object sender, System.EventArgs e)
		{
			resize();
		}

		private void openWord(WORD word)
		{
			mnuICD.Enabled = true;
			statusBar1.Text = word.title +  " ǂݍݒ";
			ITEM item = icd.GetItemById(word.id);
			cur = item;
			tbMeanig.Text = item.meaning;
			tbWord.Text = item.word.title;
			statusBar1.Text = "";
			mnuLink.MenuItems.Clear();
			if(item.links != null) 
			{
				foreach(WEBPAGE wp in item.links)
				{
					mnuLink.MenuItems.Add(new WebpageMenu(wp));
				}
				mnuLink.Enabled = true;
			} 
			else 
			{
				mnuLink.Enabled = false;
			}

			mnuRef.MenuItems.Clear();
			if(item.refs != null) 
			{
				EventHandler onclick = new EventHandler(RefMenu_Click);
				foreach(WORD w in item.refs)
				{
					mnuRef.MenuItems.Add(new RefMenu(w,onclick));
				}
				mnuRef.Enabled = true;
			}
			else 
			{
				mnuRef.Enabled = false;
			}
		}
		private void lbResult_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			openWord( ((ListItem)lbResult.SelectedItem).word );
		}

		private void mnuExit_Click(object sender, System.EventArgs e)
		{
			Application.Exit();
		}

		private void RefMenu_Click(object sender,EventArgs e)
		{
			openWord(((RefMenu)sender).word);
		}

		private void mnuICD_Click(object sender, System.EventArgs e)
		{
			System.Diagnostics.Process.Start(cur.url);
		}

		private void mnuVersion_Click(object sender, System.EventArgs e)
		{
			new frmAbout().ShowDialog(this);
		}
	}

	/// <summary>
	/// ʂListBoxɕ\邽߂̃bp[NX
	/// </summary>
	class ListItem
	{
		WORD iword;
		public WORD word 
		{
			get
			{
				return iword;
			}
		}

		public ListItem(WORD word)
		{
			iword = word;
		}
		override public string ToString()
		{
			string ret = word.title;
			if(word.english != "") 
			{
				ret += " (" + word.english + ")";
			}
			return ret;
		}
		
	}


	/// <summary>
	/// WEBPAGENXj[ɓo^邽߂̃bp[NX
	/// </summary>
	class WebpageMenu : MenuItem 
	{
		static EventHandler clickHandler;
		WEBPAGE webpage;

		public WebpageMenu(WEBPAGE webpage) : base(webpage.title)
		{
			this.webpage = webpage;
			if(clickHandler == null) 
			{
				clickHandler = new EventHandler(WebpageMenu_Click);
			}
			this.Click += clickHandler;
		}
		public void open()
		{
			System.Diagnostics.Process.Start(webpage.url);
		}
		private static void WebpageMenu_Click(object sender, System.EventArgs e)
		{
			((WebpageMenu)sender).open();
		}
	}

	/// <summary>
	/// ֘Apxj[ɓo^邽߂̃bp[NX
	/// </summary>
	class RefMenu : MenuItem
	{
		WORD iword;
		public WORD word
		{
			get
			{
				return iword;
			}
		}
		public RefMenu(WORD word,EventHandler eh) : base(word.title,eh)
		{
			this.iword = word;
		}
	}
}
